---
title: Create degradation template
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Status Pages
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create degradation template{% #create-degradation-template %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                          |
| ----------------- | ------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/statuspages/{page_id}/degradation_templates |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/statuspages/{page_id}/degradation_templates |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/statuspages/{page_id}/degradation_templates      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/statuspages/{page_id}/degradation_templates      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/statuspages/{page_id}/degradation_templates  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/statuspages/{page_id}/degradation_templates |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/statuspages/{page_id}/degradation_templates     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/statuspages/{page_id}/degradation_templates |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/statuspages/{page_id}/degradation_templates |

### Overview

Creates a new degradation template.

OAuth apps require the `status_pages_settings_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#status-pages) to access this endpoint.



### Arguments

#### Path Parameters

| Name                      | Type   | Description                |
| ------------------------- | ------ | -------------------------- |
| page_id [*required*] | string | The ID of the status page. |

#### Query Strings

| Name    | Type   | Description                                                                                                          |
| ------- | ------ | -------------------------------------------------------------------------------------------------------------------- |
| include | string | Comma-separated list of resources to include. Supported values: created_by_user, last_modified_by_user, status_page. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field        | Field                    | Type     | Description                                                                                          |
| ------------------- | ------------------------ | -------- | ---------------------------------------------------------------------------------------------------- |
|                     | data                     | object   | The data object for creating a degradation template.                                                 |
| data                | attributes               | object   | The attributes for creating a degradation template.                                                  |
| attributes          | components_affected      | [object] | The components affected by a degradation created from this template.                                 |
| components_affected | id [*required*]     | string   | The ID of the component. Must be a component of type `component`.                                    |
| components_affected | name                     | string   | The name of the component.                                                                           |
| components_affected | status [*required*] | enum     | The status of the component. Allowed enum values: `operational,degraded,partial_outage,major_outage` |
| attributes          | degradation_title        | string   | The title used for a degradation created from this template.                                         |
| attributes          | name [*required*]   | string   | The name of the degradation template.                                                                |
| attributes          | updates                  | [object] | The pre-filled updates for a degradation created from this template.                                 |
| updates             | message                  | string   | The message of the update.                                                                           |
| updates             | status [*required*] | enum     | The status of the degradation. Allowed enum values: `investigating,identified,monitoring,resolved`   |
| data                | type [*required*]   | enum     | Degradation templates resource type. Allowed enum values: `degradation_templates`                    |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "components_affected": [
        {
          "id": "",
          "status": "operational"
        }
      ],
      "degradation_title": "string",
      "name": "",
      "updates": [
        {
          "message": "string",
          "status": "investigating"
        }
      ]
    },
    "type": "degradation_templates"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response object for a single degradation template.

| Parent field          | Field                       | Type            | Description                                                                                                                                             |
| --------------------- | --------------------------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                       | data                        | object          | The data object for a degradation template.                                                                                                             |
| data                  | attributes                  | object          | The attributes of a degradation template.                                                                                                               |
| attributes            | components_affected         | [object]        | The components affected by a degradation created from this template.                                                                                    |
| components_affected   | id [*required*]        | string          | The ID of the component.                                                                                                                                |
| components_affected   | name                        | string          | The name of the component.                                                                                                                              |
| components_affected   | status [*required*]    | enum            | The status of the component. Allowed enum values: `operational,degraded,partial_outage,major_outage`                                                    |
| attributes            | created_at                  | date-time       | Timestamp of when the degradation template was created.                                                                                                 |
| attributes            | degradation_title           | string          | The title used for a degradation created from this template.                                                                                            |
| attributes            | modified_at                 | date-time       | Timestamp of when the degradation template was last modified.                                                                                           |
| attributes            | name                        | string          | The name of the degradation template.                                                                                                                   |
| attributes            | updates                     | [object]        | The pre-filled updates for a degradation created from this template.                                                                                    |
| updates               | message                     | string          | The message of the update.                                                                                                                              |
| updates               | status [*required*]    | enum            | The status of the degradation. Allowed enum values: `investigating,identified,monitoring,resolved`                                                      |
| data                  | id                          | string          | The ID of the degradation template.                                                                                                                     |
| data                  | relationships               | object          | The relationships of a degradation template.                                                                                                            |
| relationships         | created_by_user             | object          | The Datadog user who created the degradation template.                                                                                                  |
| created_by_user       | data [*required*]      | object          | The data object identifying the Datadog user who created the degradation template.                                                                      |
| data                  | id [*required*]        | string          | The ID of the Datadog user who created the degradation template.                                                                                        |
| data                  | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | last_modified_by_user       | object          | The Datadog user who last modified the degradation template.                                                                                            |
| last_modified_by_user | data [*required*]      | object          | The data object identifying the Datadog user who last modified the degradation template.                                                                |
| data                  | id [*required*]        | string          | The ID of the Datadog user who last modified the degradation template.                                                                                  |
| data                  | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | status_page                 | object          | The status page the degradation template belongs to.                                                                                                    |
| status_page           | data [*required*]      | object          | The data object identifying the status page associated with a degradation template.                                                                     |
| data                  | id [*required*]        | string          | The ID of the status page.                                                                                                                              |
| data                  | type [*required*]      | enum            | Status pages resource type. Allowed enum values: `status_pages`                                                                                         |
| data                  | type [*required*]      | enum            | Degradation templates resource type. Allowed enum values: `degradation_templates`                                                                       |
|                       | included                    | [ <oneOf>] | The included related resources of a degradation template. Client must explicitly request these resources by name in the `include` query parameter.      |
| included              | <type=users>                | object          | The included Datadog user resource.                                                                                                                     |
| <type=users>          | attributes                  | object          | Attributes of the Datadog user.                                                                                                                         |
| attributes            | email                       | string          | The email of the Datadog user.                                                                                                                          |
| attributes            | handle                      | string          | The handle of the Datadog user.                                                                                                                         |
| attributes            | icon                        | string          | The icon of the Datadog user.                                                                                                                           |
| attributes            | name                        | string          | The name of the Datadog user.                                                                                                                           |
| attributes            | uuid                        | string          | The UUID of the Datadog user.                                                                                                                           |
| <type=users>          | id                          | uuid            | The ID of the Datadog user.                                                                                                                             |
| <type=users>          | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| included              | <type=status_pages>         | object          | The included status page resource.                                                                                                                      |
| <type=status_pages>   | attributes                  | object          | The attributes of a status page.                                                                                                                        |
| attributes            | company_logo                | string          | The base64-encoded image data displayed in the company logo.                                                                                            |
| attributes            | components                  | [object]        | Components displayed on the status page.                                                                                                                |
| components            | components                  | [object]        | If the component is of type `group`, the components within the group.                                                                                   |
| components            | id                          | uuid            | The ID of the grouped component.                                                                                                                        |
| components            | name                        | string          | The name of the grouped component.                                                                                                                      |
| components            | position                    | int64           | The zero-indexed position of the grouped component. Relative to the other components in the group.                                                      |
| components            | status                      | enum            | The status of the component. Allowed enum values: `operational,degraded,partial_outage,major_outage,maintenance`                                        |
| components            | type                        | enum            | The type of the component. Allowed enum values: `component`                                                                                             |
| components            | id                          | uuid            | The ID of the component.                                                                                                                                |
| components            | name                        | string          | The name of the component.                                                                                                                              |
| components            | position                    | int64           | The zero-indexed position of the component.                                                                                                             |
| components            | status                      | enum            | The status of the component. Allowed enum values: `operational,degraded,partial_outage,major_outage,maintenance`                                        |
| components            | type                        | enum            | The type of the component. Allowed enum values: `component,group`                                                                                       |
| attributes            | created_at                  | date-time       | Timestamp of when the status page was created.                                                                                                          |
| attributes            | custom_domain               | string          | If configured, the url that the status page is accessible at.                                                                                           |
| attributes            | custom_domain_enabled       | boolean         | Whether the custom domain is configured.                                                                                                                |
| attributes            | domain_prefix               | string          | The subdomain of the status page's url taking the form `https://{domain_prefix}.statuspage.datadoghq.com`. Globally unique across Datadog Status Pages. |
| attributes            | email_header_image          | string          | Base64-encoded image data included in email notifications sent to status page subscribers.                                                              |
| attributes            | enabled                     | boolean         | Whether the status page is enabled.                                                                                                                     |
| attributes            | favicon                     | string          | Base64-encoded image data displayed in the browser tab.                                                                                                 |
| attributes            | modified_at                 | date-time       | Timestamp of when the status page was last modified.                                                                                                    |
| attributes            | name                        | string          | The name of the status page.                                                                                                                            |
| attributes            | page_url                    | string          | The url that the status page is accessible at.                                                                                                          |
| attributes            | slack_app_icon              | string          | The Slack app icon URL for the status page.                                                                                                             |
| attributes            | slack_subscriptions_enabled | boolean         | Whether Slack subscriptions are enabled for the status page.                                                                                            |
| attributes            | subscriptions_enabled       | boolean         | Whether users can subscribe to the status page.                                                                                                         |
| attributes            | type                        | enum            | The type of the status page controlling how the status page is accessed. Allowed enum values: `public,internal`                                         |
| attributes            | visualization_type          | enum            | The visualization type of the status page. Allowed enum values: `bars_and_uptime_percentage,bars_only,component_name_only`                              |
| <type=status_pages>   | id                          | uuid            | The ID of the status page.                                                                                                                              |
| <type=status_pages>   | relationships               | object          | The relationships of a status page.                                                                                                                     |
| relationships         | created_by_user             | object          | The Datadog user who created the status page.                                                                                                           |
| created_by_user       | data [*required*]      | object          | The data object identifying the Datadog user who created the status page.                                                                               |
| data                  | id [*required*]        | string          | The ID of the Datadog user who created the status page.                                                                                                 |
| data                  | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | last_modified_by_user       | object          | The Datadog user who last modified the status page.                                                                                                     |
| last_modified_by_user | data [*required*]      | object          | The data object identifying the Datadog user who last modified the status page.                                                                         |
| data                  | id [*required*]        | string          | The ID of the Datadog user who last modified the status page.                                                                                           |
| data                  | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| <type=status_pages>   | type [*required*]      | enum            | Status pages resource type. Allowed enum values: `status_pages`                                                                                         |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "components_affected": [
        {
          "id": "",
          "name": "string",
          "status": "operational"
        }
      ],
      "created_at": "2019-09-19T10:00:00.000Z",
      "degradation_title": "string",
      "modified_at": "2019-09-19T10:00:00.000Z",
      "name": "string",
      "updates": [
        {
          "message": "string",
          "status": "investigating"
        }
      ]
    },
    "id": "string",
    "relationships": {
      "created_by_user": {
        "data": {
          "id": "",
          "type": "users"
        }
      },
      "last_modified_by_user": {
        "data": {
          "id": "",
          "type": "users"
        }
      },
      "status_page": {
        "data": {
          "id": "",
          "type": "status_pages"
        }
      }
    },
    "type": "degradation_templates"
  },
  "included": [
    {
      "attributes": {
        "email": "string",
        "handle": "string",
        "icon": "string",
        "name": "string",
        "uuid": "string"
      },
      "id": "string",
      "type": "users"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export page_id="CHANGE_ME" \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/statuspages/${page_id}/degradation_templates" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "components_affected": [
        {
          "id": "1234abcd-12ab-34cd-56ef-123456abcdef",
          "status": "degraded"
        }
      ],
      "degradation_title": "Elevated API Latency",
      "name": "Elevated API Latency",
      "updates": [
        {
          "message": "We are investigating the issue.",
          "status": "investigating"
        }
      ]
    },
    "type": "degradation_templates"
  }
}
EOF 
                
##### 

```python
"""
Create degradation template returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.status_pages_api import StatusPagesApi
from datadog_api_client.v2.model.create_degradation_request_data_attributes_status import (
    CreateDegradationRequestDataAttributesStatus,
)
from datadog_api_client.v2.model.create_degradation_template_request import CreateDegradationTemplateRequest
from datadog_api_client.v2.model.create_degradation_template_request_data import CreateDegradationTemplateRequestData
from datadog_api_client.v2.model.create_degradation_template_request_data_attributes import (
    CreateDegradationTemplateRequestDataAttributes,
)
from datadog_api_client.v2.model.create_degradation_template_request_data_attributes_components_affected_items import (
    CreateDegradationTemplateRequestDataAttributesComponentsAffectedItems,
)
from datadog_api_client.v2.model.create_degradation_template_request_data_attributes_updates_items import (
    CreateDegradationTemplateRequestDataAttributesUpdatesItems,
)
from datadog_api_client.v2.model.patch_degradation_template_request_data_attributes_components_affected_items_status import (
    PatchDegradationTemplateRequestDataAttributesComponentsAffectedItemsStatus,
)
from datadog_api_client.v2.model.patch_degradation_template_request_data_type import (
    PatchDegradationTemplateRequestDataType,
)
from uuid import UUID

body = CreateDegradationTemplateRequest(
    data=CreateDegradationTemplateRequestData(
        attributes=CreateDegradationTemplateRequestDataAttributes(
            components_affected=[
                CreateDegradationTemplateRequestDataAttributesComponentsAffectedItems(
                    id="",
                    status=PatchDegradationTemplateRequestDataAttributesComponentsAffectedItemsStatus.OPERATIONAL,
                ),
            ],
            name="",
            updates=[
                CreateDegradationTemplateRequestDataAttributesUpdatesItems(
                    status=CreateDegradationRequestDataAttributesStatus.INVESTIGATING,
                ),
            ],
        ),
        type=PatchDegradationTemplateRequestDataType.DEGRADATION_TEMPLATES,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = StatusPagesApi(api_client)
    response = api_instance.create_degradation_template(page_id=UUID("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"), body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create degradation template returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::StatusPagesAPI.new

body = DatadogAPIClient::V2::CreateDegradationTemplateRequest.new({
  data: DatadogAPIClient::V2::CreateDegradationTemplateRequestData.new({
    attributes: DatadogAPIClient::V2::CreateDegradationTemplateRequestDataAttributes.new({
      components_affected: [
        DatadogAPIClient::V2::CreateDegradationTemplateRequestDataAttributesComponentsAffectedItems.new({
          id: "",
          status: DatadogAPIClient::V2::PatchDegradationTemplateRequestDataAttributesComponentsAffectedItemsStatus::OPERATIONAL,
        }),
      ],
      name: "",
      updates: [
        DatadogAPIClient::V2::CreateDegradationTemplateRequestDataAttributesUpdatesItems.new({
          status: DatadogAPIClient::V2::CreateDegradationRequestDataAttributesStatus::INVESTIGATING,
        }),
      ],
    }),
    type: DatadogAPIClient::V2::PatchDegradationTemplateRequestDataType::DEGRADATION_TEMPLATES,
  }),
})
p api_instance.create_degradation_template("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create degradation template returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	body := datadogV2.CreateDegradationTemplateRequest{
		Data: &datadogV2.CreateDegradationTemplateRequestData{
			Attributes: &datadogV2.CreateDegradationTemplateRequestDataAttributes{
				ComponentsAffected: []datadogV2.CreateDegradationTemplateRequestDataAttributesComponentsAffectedItems{
					{
						Id:     "",
						Status: datadogV2.PATCHDEGRADATIONTEMPLATEREQUESTDATAATTRIBUTESCOMPONENTSAFFECTEDITEMSSTATUS_OPERATIONAL,
					},
				},
				Name: "",
				Updates: []datadogV2.CreateDegradationTemplateRequestDataAttributesUpdatesItems{
					{
						Status: datadogV2.CREATEDEGRADATIONREQUESTDATAATTRIBUTESSTATUS_INVESTIGATING,
					},
				},
			},
			Type: datadogV2.PATCHDEGRADATIONTEMPLATEREQUESTDATATYPE_DEGRADATION_TEMPLATES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStatusPagesApi(apiClient)
	resp, r, err := api.CreateDegradationTemplate(ctx, uuid.MustParse("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"), body, *datadogV2.NewCreateDegradationTemplateOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StatusPagesApi.CreateDegradationTemplate`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `StatusPagesApi.CreateDegradationTemplate`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create degradation template returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StatusPagesApi;
import com.datadog.api.client.v2.model.CreateDegradationRequestDataAttributesStatus;
import com.datadog.api.client.v2.model.CreateDegradationTemplateRequest;
import com.datadog.api.client.v2.model.CreateDegradationTemplateRequestData;
import com.datadog.api.client.v2.model.CreateDegradationTemplateRequestDataAttributes;
import com.datadog.api.client.v2.model.CreateDegradationTemplateRequestDataAttributesComponentsAffectedItems;
import com.datadog.api.client.v2.model.CreateDegradationTemplateRequestDataAttributesUpdatesItems;
import com.datadog.api.client.v2.model.DegradationTemplate;
import com.datadog.api.client.v2.model.PatchDegradationTemplateRequestDataAttributesComponentsAffectedItemsStatus;
import com.datadog.api.client.v2.model.PatchDegradationTemplateRequestDataType;
import java.util.Collections;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    StatusPagesApi apiInstance = new StatusPagesApi(defaultClient);

    CreateDegradationTemplateRequest body =
        new CreateDegradationTemplateRequest()
            .data(
                new CreateDegradationTemplateRequestData()
                    .attributes(
                        new CreateDegradationTemplateRequestDataAttributes()
                            .componentsAffected(
                                Collections.singletonList(
                                    new CreateDegradationTemplateRequestDataAttributesComponentsAffectedItems()
                                        .id("")
                                        .status(
                                            PatchDegradationTemplateRequestDataAttributesComponentsAffectedItemsStatus
                                                .OPERATIONAL)))
                            .name("")
                            .updates(
                                Collections.singletonList(
                                    new CreateDegradationTemplateRequestDataAttributesUpdatesItems()
                                        .status(
                                            CreateDegradationRequestDataAttributesStatus
                                                .INVESTIGATING))))
                    .type(PatchDegradationTemplateRequestDataType.DEGRADATION_TEMPLATES));

    try {
      DegradationTemplate result =
          apiInstance.createDegradationTemplate(
              UUID.fromString("9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d"), body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling StatusPagesApi#createDegradationTemplate");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create degradation template returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_status_pages::CreateDegradationTemplateOptionalParams;
use datadog_api_client::datadogV2::api_status_pages::StatusPagesAPI;
use datadog_api_client::datadogV2::model::CreateDegradationRequestDataAttributesStatus;
use datadog_api_client::datadogV2::model::CreateDegradationTemplateRequest;
use datadog_api_client::datadogV2::model::CreateDegradationTemplateRequestData;
use datadog_api_client::datadogV2::model::CreateDegradationTemplateRequestDataAttributes;
use datadog_api_client::datadogV2::model::CreateDegradationTemplateRequestDataAttributesComponentsAffectedItems;
use datadog_api_client::datadogV2::model::CreateDegradationTemplateRequestDataAttributesUpdatesItems;
use datadog_api_client::datadogV2::model::PatchDegradationTemplateRequestDataAttributesComponentsAffectedItemsStatus;
use datadog_api_client::datadogV2::model::PatchDegradationTemplateRequestDataType;
use uuid::Uuid;

#[tokio::main]
async fn main() {
    let body =
        CreateDegradationTemplateRequest
        ::new().data(
            CreateDegradationTemplateRequestData::new(
                PatchDegradationTemplateRequestDataType::DEGRADATION_TEMPLATES,
            ).attributes(
                CreateDegradationTemplateRequestDataAttributes::new("".to_string())
                    .components_affected(
                        vec![
                            CreateDegradationTemplateRequestDataAttributesComponentsAffectedItems::new(
                                "".to_string(),
                                PatchDegradationTemplateRequestDataAttributesComponentsAffectedItemsStatus
                                ::OPERATIONAL,
                            )
                        ],
                    )
                    .updates(
                        vec![
                            CreateDegradationTemplateRequestDataAttributesUpdatesItems::new(
                                CreateDegradationRequestDataAttributesStatus::INVESTIGATING,
                            )
                        ],
                    ),
            ),
        );
    let configuration = datadog::Configuration::new();
    let api = StatusPagesAPI::with_config(configuration);
    let resp = api
        .create_degradation_template(
            Uuid::parse_str("00000000-0000-0000-0000-000000000000").expect("invalid UUID"),
            body,
            CreateDegradationTemplateOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create degradation template returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.StatusPagesApi(configuration);

const params: v2.StatusPagesApiCreateDegradationTemplateRequest = {
  body: {
    data: {
      attributes: {
        componentsAffected: [
          {
            id: "",
            status: "operational",
          },
        ],
        name: "",
        updates: [
          {
            status: "investigating",
          },
        ],
      },
      type: "degradation_templates",
    },
  },
  pageId: "9b1deb4d-3b7d-4bad-9bdd-2b0d7b3dcb6d",
};

apiInstance
  .createDegradationTemplate(params)
  .then((data: v2.DegradationTemplate) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
